package com.ibm.rational.report.oda.reqpro.runtime.impl;

import java.io.UnsupportedEncodingException;
import java.util.Map;
import java.util.Properties;

import org.eclipse.datatools.connectivity.oda.IConnection;
import org.eclipse.datatools.connectivity.oda.IDataSetMetaData;
import org.eclipse.datatools.connectivity.oda.IQuery;
import org.eclipse.datatools.connectivity.oda.OdaException;
import org.eclipse.datatools.enablement.oda.xml.Constants;
import org.eclipse.datatools.enablement.oda.xml.impl.Connection;

import com.ibm.rational.report.oda.reqpro.runtime.ReqProODARuntimePlugin;



/**
 * @author Suryakant Choudhary
 * @since 1.0
 */
public class ReqProConnection implements IConnection {
	
	private Connection xmlConn;
	private Map appContext;

	/* (non-Javadoc)
	 * @see org.eclipse.datatools.connectivity.oda.IConnection#close()
	 */
	public void close() throws OdaException {
		xmlConn.close();
		xmlConn = null;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.datatools.connectivity.oda.IConnection#commit()
	 */
	public void commit() throws OdaException {
		xmlConn.commit();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.datatools.connectivity.oda.IConnection#getMaxQueries()
	 */
	public int getMaxQueries() throws OdaException {
		return xmlConn.getMaxQueries();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.datatools.connectivity.oda.IConnection#getMetaData(java.lang.String)
	 */
	public IDataSetMetaData getMetaData(String dataSetType) throws OdaException {
		return xmlConn.getMetaData(dataSetType);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.datatools.connectivity.oda.IConnection#isOpen()
	 */
	public boolean isOpen() throws OdaException {
		return (xmlConn != null && xmlConn.isOpen());
	}

	/* (non-Javadoc)
	 * @see org.eclipse.datatools.connectivity.oda.IConnection#newQuery(java.lang.String)
	 */
	public IQuery newQuery(String dataSetType) throws OdaException {
		return xmlConn.newQuery(dataSetType);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.datatools.connectivity.oda.IConnection#open(java.util.Properties)
	 */
	public void open(Properties connProperties) throws OdaException {
		//String dataSourceId = connProperties.getProperty(Constants.DATASOURCE_ID);
		String sXMLFileName = (String) connProperties.get( Constants.CONST_PROP_FILELIST );
		xmlConn = getXmlConnection(sXMLFileName);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.datatools.connectivity.oda.IConnection#rollback()
	 */
	public void rollback() throws OdaException {
		xmlConn.rollback();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.datatools.connectivity.oda.IConnection#setAppContext(java.lang.Object)
	 */
	public void setAppContext(Object context) throws OdaException {
		if( context instanceof Map )
			this.appContext = (Map) context;
		if(xmlConn != null) xmlConn.setAppContext(appContext);
	}
	
	public static org.eclipse.datatools.enablement.oda.xml.impl.Connection getXmlConnection(
			String repository)
			throws OdaException{
		try{
			int iFlag = -1;  
			String url = "";
			
			//Check whether User Information is available in the URL
			if(repository.indexOf("user") !=-1 && repository.indexOf("password")!=-1)
			{
				// User Information already available
				iFlag = 1;
			}
			
			Properties xmlProps;
			xmlProps = new Properties();
			// Get the Project Name

			if (iFlag == -1) {
				// Whether REST Service or VegaDataServices
				int index  = repository.indexOf("VegaDataServices");
				
				// Use the cached use info if available else ask for it
				String sUserName = "admin", sPassword = "" , sProjectName = "";
				
				// Get the project Name
				String temp = null;
				if(index != -1)
				{
					temp = repository.substring(repository
				       			.indexOf("requisitepro/")
						+ "requisitepro/".length());
					sProjectName = temp.substring(0, temp.indexOf("/"));
				}				
				else
				{
					temp = repository.substring(repository
							.indexOf("/Servlet/project/")
							+ "/Servlet/project/".length());
					
					// Check whether the information asked is about project structure or security or project details
					if(temp.indexOf("projectstructure") != -1
							||temp.indexOf("projectsecurity") != -1 
							||temp.indexOf("fulldetails")!= -1)
					{
						// Extract the project name
						sProjectName = temp.substring(0, temp.indexOf("?"));
						
					}
					else
					{					
						sProjectName = temp.substring(0, temp.indexOf("/"));
					}
					
				}
				
				// Check if the project information is available in cache
				temp = (String) ReqProODARuntimePlugin.mUserInfo.get(sProjectName);
				
				if(temp != null)
				{					// Information present in the cache
					sUserName = temp.substring(0,temp.indexOf(":$urya:"));	
					sPassword = temp.substring(temp.indexOf(":$urya:")+ ":$urya:".length());
										
					
				}
				else
				{
					//Prompt the authentication Dialogue
			
					System.out.println("Project Name :" + sProjectName);
					// update the url with user information
					
					
//					new ReqProUserPromt().createSShell(sProjectName);
//					sUserName = ReqProUserPromt.getUserName();
//					sPassword = ReqProUserPromt.getPassWord();
					
					
					
					// Cache this information
					ReqProODARuntimePlugin.mUserInfo.put(sProjectName,
							sUserName+":$urya:"+sPassword);
					
				
				}
			
				// Update the URL with the user information
				// Check the flag for Service : Either RDS or REST
				
				
				
				//Default is RDS
				
				if(index != -1)
				{
					url = composeRDSUrl(repository, sUserName,  sPassword);
				}
				else // REST Services
				{
					url = composeRESTUrl(repository, sUserName,  sPassword);
				}
				
				
				
				//Set the XML File information
				xmlProps.setProperty(Constants.CONST_PROP_FILELIST, url);
			}
			else
			{
				xmlProps.setProperty(Constants.CONST_PROP_FILELIST, repository);
				
			}
			// Enter the Encoding Information
			xmlProps.setProperty(Constants.CONST_PROP_ENCODINGLIST, "");
			
			
			
			org.eclipse.datatools.enablement.oda.xml.impl.Connection xmlConn = new org.eclipse.datatools.enablement.oda.xml.impl.Connection();
			xmlConn.open(xmlProps);
			return xmlConn;
		} catch (OdaException e){
			throw new OdaException(e);
		} 
	}
	
	private static String composeRDSUrl(String repository, String userName, String password){
		String url = repository;
		// Append the user credentials
		
		int index = url.lastIndexOf('?');
		if(index == -1) url += '?';
		else {
			url = repository.substring(0,index);
			url += '?';
		}
		url += "username=" + userName + "&password=" + password;
		// append the filter information
		url += '&' + repository.substring(repository.lastIndexOf("?")+1);
		
		
		System.out.println(" URL after adding user info : "+ url);
		url = url.replaceAll(" ", "%20");
		return url;
	}

	private static String composeRESTUrl(String repository, String userName, String password){
		String url = repository;
		// Append the user credentials
		
		url += "&user=" + userName + "&password=" + password ;
		// append the filter information
		//url += '&' + repository.substring(repository.lastIndexOf("?")+1);
		
		
		System.out.println(" URL after adding user info : "+ url);
		url = url.replaceAll(" ", "%20");
		return url;
	}
}
